Index: palm/trunk/SOURCE/vertical_nesting_mod.f90
===================================================================
--- palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2711)
+++ palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2712)
@@ -1518,40 +1624,32 @@
                topy    = (nyf+1)/(nyc+1) * (j+1) - 1
       
-               DO if = nxl, nxr
-                   DO jf = bottomy, topy
-      
-                       eps    = ( jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
+               DO iif = nxl, nxr
+                   DO jjf = bottomy, topy
+      
+                       eps    = ( jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
                        alpha  = ( ( dyf / dyc )**2.0 - 1.0 ) / 24.0
                        eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
                        edot  = ( 1.0 - eps**2.0 ) - 2.0 * alpha
                        eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
-      
-!-- WARNING
-!-- shf,z0 not interpolated
-!-- line commented in interpolate_to_fine_flux
-!-- FG needs to read it's own data file      
-!MERGE-WIP!                    surf_def_h(0)%shf(jf,if)  = eminus * shfpr(j-1,if) &
-!MERGE-WIP!                        + edot  * shfpr(j,if)   &
-!MERGE-WIP!                        + eplus  * shfpr(j+1,if)
-!MERGE-WIP    
-!MERGE-WIP                     surf_def_h(0)%usws(jf,if) = eminus * uswspr(j-1,if) &
-!MERGE-WIP                         + edot  * uswspr(j,if)   &
-!MERGE-WIP                         + eplus  * uswspr(j+1,if)
-!MERGE-WIP    
-!MERGE-WIP                     surf_def_h(0)%vsws(jf,if) = eminus * vswspr(j-1,if) &
-!MERGE-WIP                         + edot  * vswspr(j,if)   &
-!MERGE-WIP                         + eplus  * vswspr(j+1,if)
-!MERGE-WIP    
-!MERGE                      ts(jf,if)   = eminus * tspr(j-1,if) &
-!MERGE                          + edot  * tspr(j,if)   &
-!MERGE                          + eplus  * tspr(j+1,if)
-!MERGE     
-!MERGE                      us(jf,if)   = eminus * uspr(j-1,if) &
-!MERGE                          + edot  * uspr(j,if)   &
-!MERGE                          + eplus  * uspr(j+1,if)
-!MERGE     
-!MERGE!                     z0(jf,if)   = eminus * z0pr(j-1,if) &
-!MERGE!                         + edot  * z0pr(j,if)   &
-!MERGE!                         + eplus  * z0pr(j+1,if)
+ 
+!!
+!!--   TODO
+!--    variables are not compatible with the new surface layer module
+!   
+!                    surf_def_h(0)%usws(jjf,iif) = eminus * uswspr(j-1,if) &
+!                        + edot  * uswspr(j,iif)   &
+!                        + eplus  * uswspr(j+1,iif)
+!   
+!                    surf_def_h(0)%vsws(jjf,iif) = eminus * vswspr(j-1,if) &
+!                        + edot  * vswspr(j,iif)   &
+!                        + eplus  * vswspr(j+1,iif)
+!   
+!                    ts(jjf,iif)   = eminus * tspr(j-1,if) &
+!                        + edot  * tspr(j,iif)   &
+!                        + eplus  * tspr(j+1,iif)
+!
+!                    us(jjf,iif)   = eminus * uspr(j-1,if) &
+!                        + edot  * uspr(j,iif)   &
+!                        + eplus  * uspr(j+1,iif)
       
                    END DO
@@ -1561,15 +1659,16 @@
       
       
-           DEALLOCATE( shfpr, uswspr, vswspr )
-           DEALLOCATE( tspr, uspr, z0pr )
-      
-      
-#endif
+           DEALLOCATE( uswspr, vswspr )
+           DEALLOCATE( tspr, uspr )
+      
+      
        END SUBROUTINE interpolate_to_fine_flux
    
    
+#endif       
     END SUBROUTINE vnest_init_fine
    
     SUBROUTINE vnest_boundary_conds
+#if defined( __parallel )
         !------------------------------------------------------------------------------!
         ! Description:
@@ -1591,10 +1690,11 @@
         IMPLICIT NONE
     
-        INTEGER(iwp) ::  i, j, k
-        INTEGER(iwp) ::  if, jf
-    
-        REAL(wp)    ::  c_max, denom
-    
-#if defined( __parallel )
+        INTEGER(iwp)                          :: i
+        INTEGER(iwp)                          :: j
+        INTEGER(iwp)                          :: iif
+        INTEGER(iwp)                          :: jjf
+        REAL(wp)                              :: c_max
+        REAL(wp)                              :: denom
+    
     
         !
@@ -1707,7 +1807,7 @@
     
 !-- TKE Neumann BC for FG top
-            DO jf = nys, nyn
-                DO if = nxl, nxr
-                   e(nzt+1,jf,if) = e(nzt,jf,if)
+            DO jjf = nys, nyn
+                DO iif = nxl, nxr
+                   e(nzt+1,jjf,iif) = e(nzt,jjf,iif)
                 END DO
             END DO
@@ -1731,10 +1831,8 @@
     
     
-#endif
     CONTAINS
     
        SUBROUTINE vnest_set_topbc_w
        
-#if defined( __parallel )
        
            USE arrays_3d
@@ -1746,12 +1844,22 @@
        
            IMPLICIT NONE
-       
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  wprf
-         
+
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE :: wprf
+       
            
            ALLOCATE( wprf(bdims_rem(2,1)-1:bdims_rem(2,2)+1,nxl:nxr) )
@@ -1773,12 +1881,12 @@
                    topx    = (nxf+1)/(nxc+1) * (i+1) - 1
        
-                   DO if = bottomx, topx
-       
-                       eps = (if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
+                   DO iif = bottomx, topx
+       
+                       eps = (iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
                        alpha = ( (dxf/dxc)**2.0 - 1.0) / 24.0
                        eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
                        edot  = ( 1.0 - eps**2.0 ) - 2.0 * alpha
                        eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
-                       wprf(j,if) = eminus * work3d(bdims_rem(3,1),j,i-1) &
+                       wprf(j,iif) = eminus * work3d(bdims_rem(3,1),j,i-1) &
                            + edot  * work3d(bdims_rem(3,1),j,i)   &
                            + eplus  * work3d(bdims_rem(3,1),j,i+1)
@@ -1798,9 +1906,9 @@
                topy    = (nyf+1)/(nyc+1) * (j+1) - 1
        
-               DO if = nxl, nxr
-       
-                   DO jf = bottomy, topy
-       
-                       eps = (jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
+               DO iif = nxl, nxr
+       
+                   DO jjf = bottomy, topy
+       
+                       eps = (jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
        
                        alpha = ( (dyf/dyc)**2.0 - 1.0) / 24.0
@@ -1812,7 +1920,7 @@
                        eplus = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                       w(nzt,jf,if) = eminus * wprf(j-1,if) &
-                           + edot  * wprf(j,if)   &
-                           + eplus  * wprf(j+1,if)
+                       w(nzt,jjf,iif) = eminus * wprf(j-1,iif) &
+                           + edot  * wprf(j,iif)   &
+                           + eplus  * wprf(j+1,iif)
        
                    END DO
@@ -1823,5 +1931,4 @@
 
            DEALLOCATE( wprf )
-#endif 
        
        END SUBROUTINE vnest_set_topbc_w
@@ -1830,5 +1937,4 @@
        SUBROUTINE vnest_set_topbc_u
        
-#if defined( __parallel )
        
            USE arrays_3d
@@ -1840,14 +1946,22 @@
        
            IMPLICIT NONE
-       
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  uprf
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  uprs
-         
-           
+
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: uprf
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: uprs
        
            ALLOCATE( uprf(bdims_rem(3,1):bdims_rem(3,2),nys:nyn,bdims_rem(1,1)-1:bdims_rem(1,2)+1) )
@@ -1865,7 +1979,7 @@
        
                    DO i = bdims_rem(1,1)-1, bdims_rem(1,2)+1
-                       DO jf = bottomy, topy
-       
-                           eps = (jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
+                       DO jjf = bottomy, topy
+       
+                           eps = (jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
                            alpha = ( (dyf/dyc)**2.0 - 1.0) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1873,5 +1987,5 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           uprf(k,jf,i) = eminus * work3d(k,j-1,i) &
+                           uprf(k,jjf,i) = eminus * work3d(k,j-1,i) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j+1,i)
@@ -1885,5 +1999,5 @@
            !-- Interpolation in z-direction
        
-           DO jf = nys, nyn
+           DO jjf = nys, nyn
                DO i = bdims_rem(1,1)-1, bdims_rem(1,2)+1
                    eps = ( zuf(nzt+1) - zuc(bdims_rem(3,1)+1) ) / dzc
@@ -1892,7 +2006,7 @@
                    edot  = ( 1.0 - eps**2.0 ) - 2.0 * alpha
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
-                   uprs(jf,i) = eminus * uprf(bdims_rem(3,1),jf,i)   &
-                       + edot  * uprf(bdims_rem(3,1)+1,jf,i) &
-                       + eplus  * uprf(bdims_rem(3,1)+2,jf,i)
+                   uprs(jjf,i) = eminus * uprf(bdims_rem(3,1),jjf,i)   &
+                       + edot  * uprf(bdims_rem(3,1)+1,jjf,i) &
+                       + eplus  * uprf(bdims_rem(3,1)+2,jjf,i)
                END DO
            END DO
@@ -1901,5 +2015,5 @@
            !-- Interpolation in x-direction
        
-           DO jf = nys, nyn
+           DO jjf = nys, nyn
                DO i = bdims_rem(1,1), bdims_rem(1,2)
        
@@ -1907,6 +2021,6 @@
                    topx    = (nxf+1)/(nxc+1) * (i+1) - 1
        
-                   DO if = bottomx, topx
-                       u(nzt+1,jf,if) = uprs(jf,i) + ( if * dxf - i * dxc ) * ( uprs(jf,i+1) - uprs(jf,i) ) / dxc
+                   DO iif = bottomx, topx
+                       u(nzt+1,jjf,iif) = uprs(jjf,i) + ( iif * dxf - i * dxc ) * ( uprs(jjf,i+1) - uprs(jjf,i) ) / dxc
                    END DO
        
@@ -1917,5 +2031,4 @@
        
            DEALLOCATE ( uprf, uprs )
-#endif 
        
        END SUBROUTINE vnest_set_topbc_u
@@ -1924,5 +2037,4 @@
        SUBROUTINE vnest_set_topbc_v
        
-#if defined( __parallel )
        
            USE arrays_3d
@@ -1934,12 +2046,22 @@
        
            IMPLICIT NONE
-       
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  vprf
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  vprs
+
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vprf
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: vprs
          
            
@@ -1963,12 +2085,12 @@
                        topx    = (nxf+1)/(nxc+1) * (i+1) - 1
        
-                       DO if = bottomx, topx
-       
-                           eps = (if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
+                       DO iif = bottomx, topx
+       
+                           eps = (iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
                            alpha = ( (dxf/dxc)**2.0 - 1.0) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
                            edot  = ( 1.0 - eps**2.0 ) - 2.0 * alpha
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
-                           vprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           vprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -1983,5 +2105,5 @@
        
            DO j = bdims_rem(2,1)-1, bdims_rem(2,2)+1
-               DO if = nxl, nxr
+               DO iif = nxl, nxr
        
                    eps = ( zuf(nzt+1) - zuc(bdims_rem(3,1)+1) ) / dzc
@@ -1990,7 +2112,7 @@
                    edot  = ( 1.0 - eps**2.0 ) - 2.0 * alpha
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
-                   vprs(j,if) = eminus * vprf(bdims_rem(3,1),j,if)   &
-                       + edot  * vprf(bdims_rem(3,1)+1,j,if) &
-                       + eplus  * vprf(bdims_rem(3,1)+2,j,if)
+                   vprs(j,iif) = eminus * vprf(bdims_rem(3,1),j,iif)   &
+                       + edot  * vprf(bdims_rem(3,1)+1,j,iif) &
+                       + eplus  * vprf(bdims_rem(3,1)+2,j,iif)
        
                END DO
@@ -2001,12 +2123,12 @@
        
            DO j = bdims_rem(2,1), bdims_rem(2,2)
-               DO if = nxl, nxr
+               DO iif = nxl, nxr
        
                    bottomy = (nyf+1)/(nyc+1) * j
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
        
-                   DO jf = bottomy, topy
-       
-                       v(nzt+1,jf,if) = vprs(j,if) + ( jf * dyf - j * dyc ) * ( vprs(j+1,if) - vprs(j,if) ) / dyc
+                   DO jjf = bottomy, topy
+       
+                       v(nzt+1,jjf,iif) = vprs(j,iif) + ( jjf * dyf - j * dyc ) * ( vprs(j+1,iif) - vprs(j,iif) ) / dyc
        
                    END DO
@@ -2018,5 +2140,4 @@
        
        
-#endif 
        
        END SUBROUTINE vnest_set_topbc_v
@@ -2025,5 +2146,4 @@
        SUBROUTINE vnest_set_topbc_s
        
-#if defined( __parallel )
        
            USE arrays_3d
@@ -2035,12 +2155,23 @@
        
            IMPLICIT NONE
-       
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ptprf, ptprs
-         
+
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprs
+       
            
        
@@ -2064,7 +2195,7 @@
                        topx    = (nxf+1)/(nxc+1) *(i+1) - 1
        
-                       DO if = bottomx, topx
-       
-                           eps = (if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
+                       DO iif = bottomx, topx
+       
+                           eps = (iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
        
                            alpha = ( (dxf/dxc)**2.0 - 1.0) / 24.0
@@ -2076,5 +2207,5 @@
                            eplus = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           ptprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           ptprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -2097,9 +2228,9 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
        
-                   DO if = nxl, nxr
-       
-                       DO jf = bottomy, topy
-       
-                           eps = (jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
+                   DO iif = nxl, nxr
+       
+                       DO jjf = bottomy, topy
+       
+                           eps = (jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
        
                            alpha = ( (dyf/dyc)**2.0 - 1.0) / 24.0
@@ -2111,7 +2242,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           ptprs(k,jf,if) = eminus * ptprf(k,j-1,if) &
-                               + edot  * ptprf(k,j,if)   &
-                               + eplus  * ptprf(k,j+1,if)
+                           ptprs(k,jjf,iif) = eminus * ptprf(k,j-1,iif) &
+                               + edot  * ptprf(k,j,iif)   &
+                               + eplus  * ptprf(k,j+1,iif)
                        END DO
        
@@ -2125,6 +2256,6 @@
            !-- Interpolation in z-direction
        
-           DO jf = nys, nyn
-               DO if = nxl, nxr
+           DO jjf = nys, nyn
+               DO iif = nxl, nxr
        
                    eps = ( zuf(nzt+1) - zuc(bdims_rem(3,1)+1) ) / dzc
@@ -2138,7 +2269,7 @@
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                   interpol3d (nzt+1,jf,if) = eminus * ptprs(bdims_rem(3,1),jf,if)   &
-                       + edot  * ptprs(bdims_rem(3,1)+1,jf,if) &
-                       + eplus  * ptprs(bdims_rem(3,1)+2,jf,if)
+                   interpol3d (nzt+1,jjf,iif) = eminus * ptprs(bdims_rem(3,1),jjf,iif)   &
+                       + edot  * ptprs(bdims_rem(3,1)+1,jjf,iif) &
+                       + eplus  * ptprs(bdims_rem(3,1)+2,jjf,iif)
        
                END DO
@@ -2148,11 +2279,12 @@
        
        
-#endif 
        
        END SUBROUTINE vnest_set_topbc_s
+#endif
     END SUBROUTINE vnest_boundary_conds
     
  
     SUBROUTINE vnest_boundary_conds_khkm
+#if defined( __parallel )
     
         !--------------------------------------------------------------------------------!
@@ -2175,10 +2307,11 @@
         IMPLICIT NONE
     
-        INTEGER(iwp) ::  i, j, k
-        INTEGER(iwp) ::  if, jf
-    
-        REAL(wp)    ::  c_max, denom
-    
-#if defined( __parallel )
+        INTEGER(iwp)                          :: i
+        INTEGER(iwp)                          :: j
+        INTEGER(iwp)                          :: iif
+        INTEGER(iwp)                          :: jjf
+        REAL(wp)                              :: c_max
+        REAL(wp)                              :: denom
+    
     
         IF ( coupling_mode == 'vnested_crse' )  THEN
@@ -2265,7 +2398,7 @@
     
         ! Neumann BC for FG kh
-        DO jf = nys, nyn
-            DO if = nxl, nxr
-               kh(nzt+1,jf,if) = kh(nzt,jf,if)
+        DO jjf = nys, nyn
+            DO iif = nxl, nxr
+               kh(nzt+1,jjf,iif) = kh(nzt,jjf,iif)
             END DO
         END DO
@@ -2275,7 +2408,7 @@
     
         ! Neumann BC for FG kh
-        DO jf = nys, nyn
-            DO if = nxl, nxr
-               km(nzt+1,jf,if) = km(nzt,jf,if)
+        DO jjf = nys, nyn
+            DO iif = nxl, nxr
+               km(nzt+1,jjf,iif) = km(nzt,jjf,iif)
             END DO
         END DO
@@ -2284,9 +2417,9 @@
         !
         !-- The following evaluation can only be performed, if the fine grid is situated below the inversion
-        !!    DO jf = nys-1, nyn+1
-        !!       DO if = nxl-1, nxr+1
+        !!    DO jjf = nys-1, nyn+1
+        !!       DO iif = nxl-1, nxr+1
         !!
-        !!          km(nzt+1,jf,if) = 0.1 * l_grid(nzt+1) * SQRT( e(nzt+1,jf,if) )
-        !!          kh(nzt+1,jf,if) = 3.0 * km(nzt+1,jf,if)
+        !!          km(nzt+1,jjf,iif) = 0.1 * l_grid(nzt+1) * SQRT( e(nzt+1,jjf,iif) )
+        !!          kh(nzt+1,jjf,iif) = 3.0 * km(nzt+1,jjf,iif)
         !!
         !!       END DO
@@ -2300,5 +2433,4 @@
         ENDIF
     
-#endif 
     
     CONTAINS
@@ -2306,5 +2438,4 @@
        SUBROUTINE vnest_set_topbc_kh
        
-#if defined( __parallel )
        
            USE arrays_3d
@@ -2316,12 +2447,23 @@
        
            IMPLICIT NONE
-       
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ptprf, ptprs
-         
+
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprs
+       
            
        
@@ -2345,7 +2487,7 @@
                        topx    = (nxf+1)/(nxc+1) *(i+1) - 1
        
-                       DO if = bottomx, topx
-       
-                           eps = (if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
+                       DO iif = bottomx, topx
+       
+                           eps = (iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
        
                            alpha = ( (dxf/dxc)**2.0 - 1.0) / 24.0
@@ -2357,5 +2499,5 @@
                            eplus = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           ptprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           ptprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -2378,9 +2520,9 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
        
-                   DO if = nxl, nxr
-       
-                       DO jf = bottomy, topy
-       
-                           eps = (jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
+                   DO iif = nxl, nxr
+       
+                       DO jjf = bottomy, topy
+       
+                           eps = (jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
        
                            alpha = ( (dyf/dyc)**2.0 - 1.0) / 24.0
@@ -2392,7 +2534,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           ptprs(k,jf,if) = eminus * ptprf(k,j-1,if) &
-                               + edot  * ptprf(k,j,if)   &
-                               + eplus  * ptprf(k,j+1,if)
+                           ptprs(k,jjf,iif) = eminus * ptprf(k,j-1,iif) &
+                               + edot  * ptprf(k,j,iif)   &
+                               + eplus  * ptprf(k,j+1,iif)
                        END DO
        
@@ -2406,6 +2548,6 @@
            !-- Interpolation in z-direction
        
-           DO jf = nys, nyn
-               DO if = nxl, nxr
+           DO jjf = nys, nyn
+               DO iif = nxl, nxr
        
                    eps = ( zuf(nzt+1) - zuc(bdims_rem(3,1)+1) ) / dzc
@@ -2419,7 +2561,7 @@
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                   kh (nzt+1,jf,if) = eminus * ptprs(bdims_rem(3,1),jf,if)   &
-                       + edot  * ptprs(bdims_rem(3,1)+1,jf,if) &
-                       + eplus  * ptprs(bdims_rem(3,1)+2,jf,if)
+                   kh (nzt+1,jjf,iif) = eminus * ptprs(bdims_rem(3,1),jjf,iif)   &
+                       + edot  * ptprs(bdims_rem(3,1)+1,jjf,iif) &
+                       + eplus  * ptprs(bdims_rem(3,1)+2,jjf,iif)
        
                END DO
@@ -2429,5 +2571,4 @@
        
        
-#endif 
        
        END SUBROUTINE vnest_set_topbc_kh
@@ -2435,5 +2576,4 @@
        SUBROUTINE vnest_set_topbc_km
        
-#if defined( __parallel )
        
            USE arrays_3d
@@ -2445,12 +2585,24 @@
        
            IMPLICIT NONE
-       
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ptprf, ptprs
-         
+
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprs
+       
            
        
@@ -2474,7 +2626,7 @@
                        topx    = (nxf+1)/(nxc+1) *(i+1) - 1
        
-                       DO if = bottomx, topx
-       
-                           eps = (if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
+                       DO iif = bottomx, topx
+       
+                           eps = (iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc) / dxc
        
                            alpha = ( (dxf/dxc)**2.0 - 1.0) / 24.0
@@ -2486,5 +2638,5 @@
                            eplus = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           ptprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           ptprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -2507,9 +2659,9 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
        
-                   DO if = nxl, nxr
-       
-                       DO jf = bottomy, topy
-       
-                           eps = (jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
+                   DO iif = nxl, nxr
+       
+                       DO jjf = bottomy, topy
+       
+                           eps = (jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc) / dyc
        
                            alpha = ( (dyf/dyc)**2.0 - 1.0) / 24.0
@@ -2521,7 +2673,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           ptprs(k,jf,if) = eminus * ptprf(k,j-1,if) &
-                               + edot  * ptprf(k,j,if)   &
-                               + eplus  * ptprf(k,j+1,if)
+                           ptprs(k,jjf,iif) = eminus * ptprf(k,j-1,iif) &
+                               + edot  * ptprf(k,j,iif)   &
+                               + eplus  * ptprf(k,j+1,iif)
                        END DO
        
@@ -2535,6 +2687,6 @@
            !-- Interpolation in z-direction
        
-           DO jf = nys, nyn
-               DO if = nxl, nxr
+           DO jjf = nys, nyn
+               DO iif = nxl, nxr
        
                    eps = ( zuf(nzt+1) - zuc(bdims_rem(3,1)+1) ) / dzc
